#ifndef __PROTOTYPES_H__
#define __PROTOTYPES_H__

void fatalerr(uint8_t *errmsg);
bool mapperinit(struct cart_s *cart);
int16_t msgbox(uint8_t *msgtxt, uint16_t buttons);
void setscreenmode(uint16_t modeval);
void MenuItemClick(WPARAM wParam);
void nmi6502();
void CHRswap(struct cart_s *cart, uint16_t banknum, uint16_t newbank, uint16_t banksize);
uint64_t exec6502(uint64_t tickcount);
void geniewrite(uint16_t addr, uint8_t value);
void step6502();
void reset6502();
void nmi6502();
uint16_t getPC();
uint64_t getclockticks();
uint8_t readPPU(uint16_t addr);
void writePPU(uint16_t addr, uint8_t value);
uint8_t readPPUregs(uint16_t addr);
void writePPUregs(uint16_t addr, uint8_t value);
void renderscanline(uint16_t scanline, bool skiprender);
void processinput();
uint8_t joyread(uint8_t joynum);
void joystrobe();
uint8_t readAPU(uint16_t addr);
void writeAPU(uint16_t addr, uint8_t value);
uint8_t mapperwrite(uint16_t addr, uint8_t value);
void blitframe(uint8_t *NESbuffer);
void initrecord();
void drawtext(uint8_t *text, uint16_t x, uint16_t y);
void savestate();
void loadstate();
void irq6502();
void map4irqdecrement();
void setscreenmode(uint16_t modeval);
bool loadROM(uint8_t *filename);
bool verifyexit();
void execNES();
bool stopNES();
bool initAPU(uint8_t CPUmode, uint32_t samplerate);
void killAPU();
void configurekeyboard(uint8_t controller);
void configurejoystick(uint8_t controller);
void showabout();
void write6502(uint16_t addr, uint8_t value);
bool initSDL(uint8_t *windowcaption);
int8_t *readSDLerr();
void execNES();
bool loadROM(uint8_t *filename);
void initPPU();
void killPPU();
void initinput();
void blitframe(uint8_t *NESbuffer);
void hookexternal(void *funcptr);
void reset6502();
bool initAPU(uint8_t CPUmode, uint32_t samplerate);
void tickchannelsAPU();
void drawtext(uint8_t *text, uint16_t, uint16_t y);
void loadconfig();
void saveconfig();
void pauseCPU();
void resumeCPU();
uint8_t read6502(uint16_t addr);
void mixerinput(uint8_t channel, uint8_t value);
void squarereload(uint8_t channel);

#ifdef _WIN32
DWORD WINAPI threadNES(LPVOID lParam);
DWORD WINAPI threadNES(LPVOID lParam);
#endif
#endif
